/*************************************************************************
 * File       : uart.c
 * Description: Initializes the uart0 for the required baud rate. 
 *			
 * Copyright 2004 ZiLOG Inc.  ALL RIGHTS RESERVED.

 * The source code in this file was written by an
 * authorized ZiLOG employee or a licensed consultant.
 * The source code has been verified to the fullest
 * extent possible.
 * Permission to use this code is granted on a royalty-free
 * basis. However users are cautioned to authenticate the
 * code contained herein.
 * ZiLOG DOES NOT GUARANTEE THE VERACITY OF THE SOFTWARE.
 ************************************************************************/


#include <eZ8.h>
#include "timer.h"
#include "uart.h"


/**************************************************************************************/
//  Initialize UART for:
//   - 38400 baud, 
//   - 8-bit data, 
//   - none parity, 
//   - 1 stop bit,
//   - none flow control.
/**************************************************************************************/
void init_uart0(void)
{
PAAF |= PORTA_UART_TXD | PORTA_UART_RXD;		// Enable UART0 TxD0/RxD0 pins
PAAFS1 = 0x00;
U0BRH = (char)(BRG0 >> 8);						// Program Baud Rate Register High
U0BRL = (char)(BRG0 & 0xff);					// Program Baud Rate Register Low
U0CTL0 = UART_RXD_EN | UART_TXD_EN;        		// Transmit enable, Receive Enable, No Parity, 1 Stop
U0D = '\r';
}

/**************************************************************************************/
//  Print character to console
/**************************************************************************************/
char putch(char c)
{
if (c == '\n') {
   do {
     } while (!(U0STAT0 & 0x04));  				// Transmit Data Bit enabled
    U0D = '\r';                   				// Send CR 
  }

do {
  } while (!(U0STAT0 & 0x04));  				// Transmit Data Bit enabled
U0D = c;        								// Send data
}











