/*************************************************************************
 * File       : main.c
 * Description: 

 * Copyright 2004 ZiLOG Inc.  ALL RIGHTS RESERVED.

 * The source code in this file was written by an
 * authorized ZiLOG employee or a licensed consultant.
 * The source code has been verified to the fullest
 * extent possible.
 * Permission to use this code is granted on a royalty-free
 * basis. However users are cautioned to authenticate the
 * code contained herein.
 * ZiLOG DOES NOT GUARANTEE THE VERACITY OF THE SOFTWARE.
 ************************************************************************/

#include<ez8.h>
#include "main.h"
#include "adc.h"
#include "uart.h"


extern unsigned char  valueH, valueL;
extern unsigned char print_all_data;			//Variable , to decide to send the data on  Serial port at 
								    			//every 30 minutes.
extern unsigned char store_data;				//Variable, to decide, either to store data on NVDS or not
extern unsigned char print_every_minute;	
unsigned  char address=0x00;
unsigned int  valueH_new, valueL_new;
char adc_data_available  =  NO;					// Initially ADC New data  Available
unsigned char high_byte,low_byte;
unsigned char const_buffer[]  = "Temp in deg C:";
unsigned char const_buffer1[] = "Previous Half Hour Temperature readings";
unsigned char const_buffer2[] = "Measuring the Temperature";

char NVDS_Data;									// NVDS data register
char NVDS_Address = 0x00;						// NVDS address register




void main(void)

{
 init_external_systemclock();
 init_flash();
 init_gpio();						// Initializes the GPIO port (refer to gpio.c file) 
 init_timer0();
 init_adc();
 init_uart0();
 turn_off__all_led();
 puts(const_buffer2);
 putch('\n');
 ADCCTL0  |= ADC_EN;				// ADC Conversion Enable
 EI();

while(1)
	{
	
		int  measured_temp;
		measured_temp=actual_temp();
		if((measured_temp > LOW_SET_TEMP ) && (measured_temp < HIGH_SET_TEMP))
			{
				 normal_rangeLED_on();
			}
		else if(measured_temp < LOW_SET_TEMP)
	   		{
	   			 low_limitLED_on();
	   		}
		else if(measured_temp > HIGH_SET_TEMP)
		   {
	 			 high_limitLED_on();  
	  	   }
	
	 if(print_every_minute == YES)
	 	
	 		{
				


				print_every_minute = NO;					//reset the Flag
				puts(const_buffer);
				display_data(measured_temp);
			
			}
	if(store_data == YES)
			{

				store_data = NO;
				DI();
				NVDS_Data= valueH;							// NVDS data register
				NVDS_Write();			
				NVDS_Data= valueL;							// NVDS data register
				++NVDS_Address;
				NVDS_Write();			
				++NVDS_Address;
				EI();
		
			}

	if(print_all_data == YES)
			{
				DI();
				display_all_data();
				print_all_data = NO;
				NVDS_Address = 0x00; 	//reset the  NVDS starting address.	
				putch('\n');
				puts(const_buffer2);
 				putch('\n');		
				EI();
				
			}
	

	}
}

/**************************************************************************************/
//Explain this function
//10-bit analog output is used for temp measurement (sign bit is ignored)
/**************************************************************************************/


unsigned int actual_temp()				
{
	if(adc_data_available == YES)			//check if new data available
	{
		 //Read the temp
		 adc_data_available = NO;
		 valueH_new = (unsigned char)valueH;
		 valueL_new = (unsigned char)valueL;
		valueL_new = valueL_new >> 5;									// Shift right 5 bits of ADC Data Low

		valueH_new = valueH_new <<3;									// Get Temp Data High byte (Hex) 

		valueH_new |= valueL_new;

		valueH_new = (valueH_new - 0x18B);				//0x18B is value at 0 deg C.
		valueH_new = valueH_new/5;						//Refer to Temperature sensor 
														//transfer Function table in the product spec

 		return(valueH_new);
	}
	    return(valueH_new);
}//End of Actual temperature function


char NVDS_Write(void)
{
	asm("\tLDX	R2, _NVDS_Address");
	asm("\tPUSH	R2");
	asm("\tLDX	R2, _NVDS_Data");
	asm("\tPUSH	R2");
	asm("\tCALL 	%10B3");
	asm("\tPOP	R2");
	asm("\tPOP	R2");
}//End of NVDS write function



char NVDS_Read ()
{
	asm("\tLDX	R2, _NVDS_Address");
	asm("\tPUSH	R2");
	asm("\tCALL 	%1000");
	asm("\tPOP	R2");
}//End of NVDS_Read function

void display_all_data(void)
{
	unsigned int  display_valueH, display_valueL;
	int  temp_data;
	NVDS_Address = 0x00;
	puts(const_buffer1);
	putch('\n');
	while(NVDS_Address < 0x0C)
	{
		puts(const_buffer);
		high_byte = NVDS_Read ();     // read from  NVDS at "address" 
		NVDS_Address++;
		low_byte =  NVDS_Read ();
		NVDS_Address++;			
		display_valueL = low_byte >> 5;									// Shift right 5 bits of ADC Data Low
		display_valueH = high_byte << 3;									// Get Temp Data High byte (Hex) 
		display_valueH |= display_valueL;
		display_valueH = (display_valueH - 0x18B);
		display_valueH = display_valueH/5;
		display_data(display_valueH);
	}
}//End of display_all_data


	
	void init_external_systemclock()
{
	OSCCTL = 0xE7;					// Unlock sequence for OSCTL write
	OSCCTL = 0x18;					//
   	OSCCTL	=0xE2;					// Crystal oscillator is enabled
									// Internal precision oscillator is Enabled
									// WDT oscillator enabled
									// Failure detection and recovery of primary oscillator is enebled
									// Crystal or external RC oscillator as system clock
}//End of init_external_systemclock routine
	

void display_data(unsigned int measured_temp)
{
	unsigned char H_byte,L_byte;
	char buffer[3];
	buffer[0] = 0x00;
	L_byte = (unsigned char)(measured_temp);
	bin_to_decimal(L_byte, buffer);
	puts(buffer);
	putch('\n');
}//End of display data routine


/**************************************************************************************/
//  Print string to console
/**************************************************************************************/
void puts (char far * src)
{
while (*src)									// Print character to console
   putch (*src++);								// until null termination of the string
}//End of puts routine

/**************************************************************************************/

/**************************************************************************************/
void bin_to_decimal(unsigned char c, char *buffer) 
{

	while(*buffer)
 	{
  		buffer++;
  	}
  	buffer[1] = (c%10) + '0';
	c/=10;
	buffer[0]= (c%10) + '0';
	buffer[2] ='\0';
  
}//End of bin_to_decimal routine


void init_flash(void)
{
	FPFH = 0x1F;		// Program Flash frequency registers to 8MHz
	FPFL = 0x40;

}



