/*************************************************************************
 * File       : timer.h
 * Description: 
 * Copyright 2004 ZiLOG Inc.  ALL RIGHTS RESERVED.
			
 * The source code in this file was written by an
 * authorized ZiLOG employee or a licensed consultant.
 * The source code has been verified to the fullest
 * extent possible.
 * Permission to use this code is granted on a royalty-free
 * basis. However users are cautioned to authenticate the
 * code contained herein.
 * ZiLOG DOES NOT GUARANTEE THE VERACITY OF THE SOFTWARE.
 ************************************************************************/
//This sequence of defines, helps to calculate the  Reload value of 
//the timer, to get an interrupt at every second.
#define SYSTEMCLOCK	    8000000		// CPU working frequency 8000000  
#define PRESCALE		128			//Pre scalar setting
#define TIMEOUT			1			//Generate interrupt at every second 
#define RELOADVALUE		((SYSTEMCLOCK * TIMEOUT)/PRESCALE)  //Reload value to be loaded to Timer Reload Register
#define TIMER_START_VALUE	0		// Timer counting to start from 0

//*******************************************************
#if ( PRESCALE == 128)
	#define SET_PRESCALE	(char)0x38
#else if (PRESCALE == 64)
	#define SET_PRESCALE	(char)0x30
#else if (PRESCALE == 32)
	#define SET_PRESCALE	(char)0x28
#else if (PRESCALE == 16)
	#define SET_PRESCALE 	(char)0x20
#else if (PRESCALE == 8)
	#define SET_PRESCALE    (char)0x18
#else if (PRESCALE == 4)
	#define SET_PRESCALE    (char)0x10
#else if (PRESCALE == 2)
	#define SET_PRESCALE	(char)0x08
#else if (PRESCALE == 1)
	#define SET_PRESCALE	(char)0x00
#endif


